import basic from 'cldr-annotations-full/annotations/en/annotations.json' assert {type: 'json'};
import derived from 'cldr-annotations-derived-full/annotationsDerived/en/annotations.json' assert {type: 'json'};
import rgi from '@unicode/unicode-15.0.0/Sequence_Property/RGI_Emoji/index.js';
import flag from '@unicode/unicode-15.0.0/Sequence_Property/RGI_Emoji_Flag_Sequence/index.js';
import zwj from '@unicode/unicode-15.0.0/Sequence_Property/RGI_Emoji_ZWJ_Sequence/index.js';

const accents = /[\u0300-\u036f’]/g;
const parens = /\([^\(\)]+\)/g;
const invalid = /[^a-z0-9]+/g;

let out = {};
const slug = e => e.normalize('NFD')
	.replace(accents, '')
	.replace(parens, '')
	.toLowerCase().trim()
	.replace(invalid, '_');
const register = coll => e => {
	if (e in out) return;
	const a = coll.annotations[e];
	const n = a?.tts[0];
	const k = a?.default;
	if (!a || !n || !k) return;
	const s = slug(n);
	out[e] = {
		emoji: e,
		name: n,
		slug: s,
		keywords: k.sort(),
	};
}

const basicset = [rgi, zwj].flat();
const derivedset = [flag].flat();

basicset.forEach(register(basic.annotations));
derivedset.forEach(register(derived.annotationsDerived));

let outarr = [];
for (const k in out) outarr.push(out[k]);
// outarr.forEach(e => console.log(`${e.emoji} :${e.slug}: = ${e.name} [${e.keywords}]`));
export {out};
